#include "Settings.h"

void WaypointManager::Settings::setHomePosition(QGeoCoordinate &c)
{
    _homePosition = c;
}
void WaypointManager::Settings::setVehicle(Vehicle *vehicle)
{
    _vehicle = vehicle;
}

void WaypointManager::Settings::setIsFlyView(bool isFlyView)
{
    _isFlyView = isFlyView;
}

void WaypointManager::Settings::setArrivalReturnSpeed(double speed)
{
    if (speed > 0)
        _arrivalReturnSpeed = speed;
}

void WaypointManager::Settings::setFlightSpeed(double speed)
{
    if ( speed > 0)
        _flightSpeed = speed;
}

void WaypointManager::Settings::setAltitude(double altitude)
{
    if ( altitude > 0)
        _altitude = altitude;
}

const QGeoCoordinate &WaypointManager::Settings::homePosition() const
{
    return _homePosition;
}

Vehicle *WaypointManager::Settings::vehicle() const
{
    return _vehicle;
}

bool WaypointManager::Settings::isFlyView() const
{
    return _isFlyView;
}

double WaypointManager::Settings::arrivalReturnSpeed() const
{
    return _arrivalReturnSpeed;
}

double WaypointManager::Settings::flightSpeed() const
{
    return _flightSpeed;
}

double WaypointManager::Settings::altitude() const
{
    return _altitude;
}
