#pragma once

#include <QGeoCoordinate>

#include "Vehicle.h"

namespace WaypointManager {

class Settings
{
public:
    Settings();

    void setHomePosition(QGeoCoordinate &c);
    void setVehicle(Vehicle *vehicle);
    void setIsFlyView(bool isFlyView);
    void setArrivalReturnSpeed(double speed);
    void setFlightSpeed(double speed);
    void setAltitude(double altitude);

    const QGeoCoordinate &homePosition() const;
    Vehicle *vehicle() const;
    bool isFlyView() const;
    double arrivalReturnSpeed() const;
    double flightSpeed() const;
    double altitude() const;

private:
    QGeoCoordinate _homePosition;
    Vehicle       *_vehicle;
    bool           _isFlyView;
    double         _arrivalReturnSpeed;
    double         _flightSpeed;
    double         _altitude;

};

} // namespace WaypointManager
